#include "stack.h"

#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

void stack_init(Stack *s, int32_t size) {
    s->size = size;
    s->top = -1;
    s->data = (char **)malloc(sizeof(char *) * s->size);

    for (int32_t i = 0; i < s->size; i += 1) {
        s->data[i] = (char *)malloc(sizeof(char) * 100);
    }
}

bool stack_is_empty(Stack *s) {
    return s->top == -1;
}

void stack_push(Stack *s, char *value) {
    if (s->size == s->top + 1) {
        return;
    }

    s->top += 1;
    strcpy(s->data[s->top], value);
}

void stack_pop(Stack *s, char *value) {
    if (stack_is_empty(s)) {
        return;
    }

    stack_peek(s, value);
    s->top -= 1;
}

void stack_peek(Stack *s, char *value) {
    if (stack_is_empty(s)) {
        return;
    }

    strcpy(value, s->data[s->top]);
}

void stack_destroy(Stack *s) {
    for (int32_t i = 0; i < s->size; i += 1) {
        free(s->data[i]);
    }

    s->size = -1;
    s->top = -1;
    free(s->data);
    s->data = NULL;
}
